org.codehaus.plexus.interpolation

## Class StringSearchInterpolator

- java.lang.Object
- - org.codehaus.plexus.interpolation.StringSearchInterpolator

All Implemented Interfaces:
  Interpolator

    public class StringSearchInterpolator
    extends java.lang.Object
    implements Interpolator

### Field Summary

Fields
`static java.lang.String` `DEFAULT_END_EXPR`
`static java.lang.String` `DEFAULT_START_EXPR`

### Constructor Summary

Constructors
Constructor and Description
`StringSearchInterpolator()`
`StringSearchInterpolator(java.lang.String startExpr, java.lang.String endExpr)`

### Method Summary

Methods
`void` `addPostProcessor(InterpolationPostProcessor postProcessor)` Add a new post-processor to handle final processing after recursively-interpolated value is determined.
`void` `addValueSource(ValueSource valueSource)` Add a new `ValueSource` to the stack used to resolve expressions in this interpolator instance.
`void` `clearAnswers()`
`void` `clearFeedback()` Clear the feedback messages from previous interpolate(..) calls.
`java.lang.String` `getEscapeString()`
`java.util.List` `getFeedback()` Return any feedback messages and errors that were generated - but suppressed - during the interpolation process.
`java.lang.String` `interpolate(java.lang.String input)` See `Interpolator.interpolate(String, String, RecursionInterceptor)`.
`java.lang.String` `interpolate(java.lang.String input, RecursionInterceptor recursionInterceptor)` Entry point for recursive resolution of an expression and all of its nested expressions.
`java.lang.String` `interpolate(java.lang.String input, java.lang.String thisPrefixPattern)` See `Interpolator.interpolate(String, String, RecursionInterceptor)`.
`java.lang.String` `interpolate(java.lang.String input, java.lang.String thisPrefixPattern, RecursionInterceptor recursionInterceptor)` Attempt to resolve all expressions in the given input string, using the given pattern to first trim an optional prefix from each expression.
`boolean` `isCacheAnswers()`
`void` `removePostProcessor(InterpolationPostProcessor postProcessor)` Remove the given post-processor.
`void` `removeValuesSource(ValueSource valueSource)` Remove the specified `ValueSource` from the stack used to resolve expressions in this interpolator instance.
`void` `setCacheAnswers(boolean cacheAnswers)`
`void` `setEscapeString(java.lang.String escapeString)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### DEFAULT_START_EXPR

    public static final java.lang.String DEFAULT_START_EXPR

See Also:
  Constant Field Values

#### DEFAULT_END_EXPR

    public static final java.lang.String DEFAULT_END_EXPR

See Also:
  Constant Field Values

### Constructor Detail

#### StringSearchInterpolator

    public StringSearchInterpolator()

#### StringSearchInterpolator

    public StringSearchInterpolator(java.lang.String startExpr,
                            java.lang.String endExpr)

### Method Detail

#### addValueSource

    public void addValueSource(ValueSource valueSource)

Add a new `ValueSource` to the stack used to resolve expressions in this interpolator instance.

Specified by:
  `addValueSource` in interface `Interpolator`

#### removeValuesSource

    public void removeValuesSource(ValueSource valueSource)

Remove the specified `ValueSource` from the stack used to resolve expressions in this interpolator instance.

Specified by:
  `removeValuesSource` in interface `Interpolator`

#### addPostProcessor

    public void addPostProcessor(InterpolationPostProcessor postProcessor)

Add a new post-processor to handle final processing after recursively-interpolated value is determined.

Specified by:
  `addPostProcessor` in interface `Interpolator`

#### removePostProcessor

    public void removePostProcessor(InterpolationPostProcessor postProcessor)

Remove the given post-processor.

Specified by:
  `removePostProcessor` in interface `Interpolator`

#### interpolate

    public java.lang.String interpolate(java.lang.String input,
                               java.lang.String thisPrefixPattern)
                                 throws InterpolationException

Description copied from interface: `Interpolator`
See `Interpolator.interpolate(String, String, RecursionInterceptor)`.
This method triggers the use of a `SimpleRecursionInterceptor` instance for protection against expression cycles.

Specified by:
  `interpolate` in interface `Interpolator`
Parameters:
  `input` - The input string to interpolate
  `thisPrefixPattern` - An optional pattern that should be trimmed from the start of any expressions found in the input.
Throws:
  `InterpolationException`

#### interpolate

    public java.lang.String interpolate(java.lang.String input,
                               java.lang.String thisPrefixPattern,
                               RecursionInterceptor recursionInterceptor)
                                 throws InterpolationException

Description copied from interface: `Interpolator`
Attempt to resolve all expressions in the given input string, using the given pattern to first trim an optional prefix from each expression. The supplied recursion interceptor will provide protection from expression cycles, ensuring that the input can be resolved or an exception is thrown. return an empty String if input is null

Specified by:
  `interpolate` in interface `Interpolator`
Parameters:
  `input` - The input string to interpolate
  `thisPrefixPattern` - An optional pattern that should be trimmed from the start of any expressions found in the input.
  `recursionInterceptor` - Used to protect the interpolation process from expression cycles, and throw an exception if one is detected.
Throws:
  `InterpolationException`

#### interpolate

    public java.lang.String interpolate(java.lang.String input)
                                 throws InterpolationException

Description copied from interface: `Interpolator`
See `Interpolator.interpolate(String, String, RecursionInterceptor)`.
This method triggers the use of a `SimpleRecursionInterceptor` instance for protection against expression cycles. It also leaves empty the expression prefix which would otherwise be trimmed from expressions. The result is that any detected expression will be resolved as-is.

Specified by:
  `interpolate` in interface `Interpolator`
Parameters:
  `input` - The input string to interpolate
Throws:
  `InterpolationException`

#### interpolate

    public java.lang.String interpolate(java.lang.String input,
                               RecursionInterceptor recursionInterceptor)
                                 throws InterpolationException

Entry point for recursive resolution of an expression and all of its nested expressions.

Specified by:
  `interpolate` in interface `Interpolator`
Parameters:
  `input` - The input string to interpolate
  `recursionInterceptor` - Used to protect the interpolation process from expression cycles, and throw an exception if one is detected.
Throws:
  `InterpolationException`

#### getFeedback

    public java.util.List getFeedback()

Return any feedback messages and errors that were generated - but suppressed - during the interpolation process. Since unresolvable expressions will be left in the source string as-is, this feedback is optional, and will only be useful for debugging interpolation problems.

Specified by:
  `getFeedback` in interface `Interpolator`
Returns:
  a `List` that may be interspersed with `String` and `Throwable` instances.

#### clearFeedback

    public void clearFeedback()

Clear the feedback messages from previous interpolate(..) calls.

Specified by:
  `clearFeedback` in interface `Interpolator`

#### isCacheAnswers

    public boolean isCacheAnswers()

Specified by:
  `isCacheAnswers` in interface `Interpolator`

#### setCacheAnswers

    public void setCacheAnswers(boolean cacheAnswers)

Specified by:
  `setCacheAnswers` in interface `Interpolator`

#### clearAnswers

    public void clearAnswers()

Specified by:
  `clearAnswers` in interface `Interpolator`

#### getEscapeString

    public java.lang.String getEscapeString()

#### setEscapeString

    public void setEscapeString(java.lang.String escapeString)